import { Observable, BehaviorSubject } from 'rxjs';
import { CubeApiOptions, DryRunResponse, LoadMethodOptions, Meta, Query, ResultSet, SqlQuery } from '@cubejs-client/core';
import * as i0 from "@angular/core";
export type CubeConfig = {
    token: string;
    options?: CubeApiOptions;
};
export declare class CubeClient {
    private config;
    ready$: BehaviorSubject<boolean>;
    private cubeApi;
    constructor(config: any | Observable<any>);
    private apiInstance;
    load(query: Query | Query[], options?: LoadMethodOptions): Observable<ResultSet<any>>;
    sql(query: Query | Query[], options?: LoadMethodOptions): Observable<SqlQuery>;
    dryRun(query: Query | Query[], options?: LoadMethodOptions): Observable<DryRunResponse>;
    meta(options?: LoadMethodOptions): Observable<Meta>;
    watch(query: any, params?: {}): Observable<ResultSet<any>>;
    static ɵfac: i0.ɵɵFactoryDeclaration<CubeClient, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<CubeClient>;
}
