import { Query as TCubeQuery, PivotConfig as TPivotConfig } from '@cubejs-client/core';
import { BehaviorSubject } from 'rxjs';
import { CubeClient } from '../client';
import { Query } from './query';
import { BuilderMeta } from './builder-meta';
import { PivotConfig } from './pivot-config';
import { ChartType, TChartType } from './chart-type';
import * as i0 from "@angular/core";
export type TQueryBuilderState = {
    query?: TCubeQuery;
    pivotConfig?: TPivotConfig;
    chartType?: TChartType;
};
export declare class QueryBuilderService {
    private _cube;
    private _meta;
    private _query;
    private _disableHeuristics;
    private _resolveQuery;
    private _resolveBuilderMeta;
    private _heuristicChange$;
    readonly builderMeta: Promise<BuilderMeta>;
    readonly query: Promise<Query>;
    readonly state: BehaviorSubject<TQueryBuilderState>;
    pivotConfig: PivotConfig;
    chartType: ChartType;
    private init;
    private _handleQueryChange;
    setCubeClient(cubeClient: CubeClient): void;
    private subscribe;
    deserialize(state: any): Promise<void>;
    setPartialState(partialState: any): void;
    disableHeuristics(): void;
    enableHeuristics(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<QueryBuilderService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<QueryBuilderService>;
}
